/// Mixin to extend entity classes with. Each entity type that should be stored
/// must use this mixin to be supported.
mixin SodaEntity {
  /// Unique entity ID. Auto generated by SodaDB. Do not modify or set manually.
  int id;

  @override
  bool operator ==(Object other) =>
      identical(this, other) ||
      other is SodaEntity && runtimeType == other.runtimeType && id == other.id;

  @override
  int get hashCode => id.hashCode;
}
